## kguiaddons 5.68.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

set(KF5_VERSION "5.68.0") # handled by release scripts
project(KGuiAddons VERSION ${KF5_VERSION})

include(FeatureSummary)
find_package(ECM 5.68.0  NO_MODULE)
set_package_properties(ECM PROPERTIES TYPE REQUIRED DESCRIPTION "Extra CMake Modules." URL "https://commits.kde.org/extra-cmake-modules")
feature_summary(WHAT REQUIRED_PACKAGES_NOT_FOUND FATAL_ON_MISSING_REQUIRED_PACKAGES)


set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDEFrameworkCompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings)
set(REQUIRED_QT_VERSION 5.12.0)
find_package(Qt5Gui ${REQUIRED_QT_VERSION} REQUIRED NO_MODULE)

if (NOT APPLE AND NOT WIN32)
    find_package(X11 MODULE)
    find_package(XCB MODULE COMPONENTS XCB)
endif()


include(GenerateExportHeader)
include(ECMSetupVersion)
include(ECMGenerateHeaders)
include(ECMAddQch)

ecm_setup_version(PROJECT VARIABLE_PREFIX KGUIADDONS
                        VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kguiaddons_version.h"
                        PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KF5GuiAddonsConfigVersion.cmake"
                        SOVERSION 5)

option(BUILD_QCH "Build API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)" OFF)
add_feature_info(QCH ${BUILD_QCH} "API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)")
add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x050d00)
add_definitions(-DQT_NO_FOREACH)
add_subdirectory(src)
if (BUILD_TESTING)
    add_subdirectory(autotests)
    add_subdirectory(tests)
endif()

# create a Config.cmake and a ConfigVersion.cmake file and install them
set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KF5GuiAddons")

if (BUILD_QCH)
    ecm_install_qch_export(
        TARGETS KF5GuiAddons_QCH
        FILE KF5GuiAddonsQchTargets.cmake
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
        COMPONENT Devel
    )
    set(PACKAGE_INCLUDE_QCHTARGETS "include(\"\${CMAKE_CURRENT_LIST_DIR}/KF5GuiAddonsQchTargets.cmake\")")
endif()

include(CMakePackageConfigHelpers)

configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/KF5GuiAddonsConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/KF5GuiAddonsConfig.cmake"
                              INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
                              )

install(FILES  "${CMAKE_CURRENT_BINARY_DIR}/KF5GuiAddonsConfig.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/KF5GuiAddonsConfigVersion.cmake"
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
        COMPONENT Devel )


install(EXPORT KF5GuiAddonsTargets DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
        FILE KF5GuiAddonsTargets.cmake NAMESPACE KF5:: COMPONENT Devel)


install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kguiaddons_version.h
        DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF5} COMPONENT Devel )

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/CMakeLists.txt ===

set(kguiaddons_LIB_SRCS
 colors/kcolorspaces.cpp
 colors/kcolorutils.cpp
 colors/kcolorcollection.cpp
 colors/kcolormimedata.cpp
 text/kdatevalidator.cpp
 text/kwordwrap.cpp
 fonts/kfontutils.cpp
 util/kiconutils.cpp
 util/klocalimagecacheimpl.cpp
 util/kmodifierkeyinfo.cpp
 util/kmodifierkeyinfoprovider.cpp
 util/urlhandler.cpp
)

set (kguiaddons_LIB_SRCS ${kguiaddons_LIB_SRCS} util/kmodifierkeyinfoprovider.cpp)

add_library(KF5GuiAddons ${kguiaddons_LIB_SRCS})

generate_export_header(KF5GuiAddons BASE_NAME KGuiAddons)
add_library(KF5::GuiAddons ALIAS KF5GuiAddons)

set(kguiaddons_INCLUDES
  ${CMAKE_CURRENT_SOURCE_DIR}/colors
  ${CMAKE_CURRENT_SOURCE_DIR}/fonts
  ${CMAKE_CURRENT_SOURCE_DIR}/text
  ${CMAKE_CURRENT_SOURCE_DIR}/util
  )
target_include_directories(KF5GuiAddons PUBLIC "$<BUILD_INTERFACE:${kguiaddons_INCLUDES}>")
target_include_directories(KF5GuiAddons INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR_KF5}/KGuiAddons>" )
target_compile_definitions(KF5GuiAddons INTERFACE "$<INSTALL_INTERFACE:KGUIADDONS_LIB>")
target_link_libraries(KF5GuiAddons PUBLIC Qt5::Gui)

set(WITH_XCB)
if (NOT APPLE AND X11_FOUND AND X11_Xkb_FOUND AND XCB_XCB_FOUND)
    find_package(Qt5X11Extras ${REQUIRED_QT_VERSION} NO_MODULE)
    if (Qt5X11Extras_FOUND)
        add_library(kmodifierkey_xcb MODULE util/kmodifierkeyinfoprovider_xcb.cpp)
        target_include_directories (kmodifierkey_xcb PRIVATE
            ${X11_Xkb_INCLUDE_PATH}
            ${X11_Xlib_INCLUDE_PATH}
            ${XCB_XCB_INCLUDE_DIR}
        )
        target_link_libraries(kmodifierkey_xcb PRIVATE ${X11_LIBRARIES} ${XCB_XCB_LIBRARY} Qt5::X11Extras KF5::GuiAddons)
        install( TARGETS kmodifierkey_xcb DESTINATION ${PLUGIN_INSTALL_DIR}/kf5/kguiaddons/kmodifierkey/)
    endif()
endif ()

set_target_properties(KF5GuiAddons PROPERTIES VERSION   ${KGUIADDONS_VERSION_STRING}
                                              SOVERSION ${KGUIADDONS_SOVERSION}
                                              EXPORT_NAME GuiAddons
)

ecm_generate_headers(KGuiAddons_HEADERS
  HEADER_NAMES
  KColorUtils
  KColorCollection
  KColorMimeData

  RELATIVE colors
  REQUIRED_HEADERS KGuiAddons_HEADERS
)
ecm_generate_headers(KGuiAddons_HEADERS
  HEADER_NAMES
  KDateValidator
  KWordWrap

  RELATIVE text
  REQUIRED_HEADERS KGuiAddons_HEADERS
)
ecm_generate_headers(KGuiAddons_HEADERS
  HEADER_NAMES
  KFontUtils

  RELATIVE fonts
  REQUIRED_HEADERS KGuiAddons_HEADERS
)
ecm_generate_headers(KGuiAddons_HEADERS
  HEADER_NAMES
  KIconUtils
  KImageCache
  KModifierKeyInfo

  RELATIVE util
  REQUIRED_HEADERS KGuiAddons_HEADERS
)

find_package(PythonModuleGeneration)

if (PythonModuleGeneration_FOUND)
  ecm_generate_python_binding(
    TARGET KF5::GuiAddons
    PYTHONNAMESPACE PyKF5
    MODULENAME KGuiAddons
    SIP_DEPENDS
      QtGui/QtGuimod.sip
    HEADERS
      colors/kcolorutils.h
      colors/kcolorcollection.h
      colors/kcolormimedata.h
      text/kdatevalidator.h
      text/kwordwrap.h
      fonts/kfontutils.h
      util/kiconutils.h
      util/kimagecache.h
      util/kmodifierkeyinfo.h
  )
endif()

install(TARGETS KF5GuiAddons EXPORT KF5GuiAddonsTargets ${KF5_INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/kguiaddons_export.h
  util/kmodifierkeyinfoprovider_p.h
  util/klocalimagecacheimpl.h # implementation detail, no forwarding header
  ${KGuiAddons_HEADERS}
  DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF5}/KGuiAddons COMPONENT Devel
)

if(BUILD_QCH)
    ecm_add_qch(
        KF5GuiAddons_QCH
        NAME KGuiAddons
        BASE_NAME KF5GuiAddons
        VERSION ${KF5_VERSION}
        ORG_DOMAIN org.kde
        SOURCES # using only public headers, to cover only public API
            ${KGuiAddons_HEADERS}
        MD_MAINPAGE "${CMAKE_SOURCE_DIR}/README.md"
        LINK_QCHS
            Qt5Gui_QCH
        INCLUDE_DIRS
            ${CMAKE_CURRENT_BINARY_DIR}
            ${kguiaddons_INCLUDES}
        BLANK_MACROS
            KGUIADDONS_EXPORT
        TAGFILE_INSTALL_DESTINATION ${KDE_INSTALL_QTQCHDIR}
        QCH_INSTALL_DESTINATION ${KDE_INSTALL_QTQCHDIR}
        COMPONENT Devel
    )
endif()

include(ECMGeneratePriFile)
ecm_generate_pri_file(BASE_NAME KGuiAddons LIB_NAME KF5GuiAddons DEPS "gui" FILENAME_VAR PRI_FILENAME INCLUDE_INSTALL_DIR ${KDE_INSTALL_INCLUDEDIR_KF5}/KGuiAddons)
install(FILES ${PRI_FILENAME} DESTINATION ${ECM_MKSPECS_INSTALL_DIR})

=== debian/changelog ===
kguiaddons (5.68.0-0ubuntu1) focal; urgency=medium

  * New upstream release (5.68.0)
  * Update symbols from build logs.

 -- Rik Mills <rikmills@kde.org>  Wed, 25 Mar 2020 20:57:19 +0000

kguiaddons (5.67.0-0ubuntu1) focal; urgency=medium

  * New upstream release (5.67.0)

 -- Rik Mills <rikmills@kde.org>  Sat, 08 Feb 2020 09:50:05 +0000

kguiaddons (5.66.0-0ubuntu1) focal; urgency=medium

  * New upstream release (5.66.0)

 -- Rik Mills <rikmills@kde.org>  Sat, 11 Jan 2020 13:18:56 +0000

kguiaddons (5.65.0-0ubuntu1) focal; urgency=medium

  * New upstream release (5.65.0)

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Sat, 14 Dec 2019 23:00:10 +0000

kguiaddons (5.64.0-0ubuntu1) focal; urgency=medium

  * New upstream release (5.63.0)
  * New upstream release (5.64.0)

 -- Rik Mills <rikmills@kde.org>  Sat, 09 Nov 2019 21:24:18 +0000

=== debian/control ===
Source: kguiaddons
Section: libs
Priority: optional
Maintainer: Debian/Kubuntu Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Maximiliano Curia <maxy@debian.org>
Build-Depends: cmake (>= 3.0~),
               debhelper (>= 11~),
               doxygen,
               extra-cmake-modules (>= 5.68.0~),
               graphviz,
               libqt5sql5-sqlite:native,
               libqt5x11extras5-dev (>= 5.8.0~),
               libx11-dev,
               libxcb1-dev,
               pkg-config,
               pkg-kde-tools (>= 0.15.15ubuntu1~),
               qtbase5-dev (>= 5.8.0~),
               qtbase5-private-dev (>= 5.6.1~),
               qttools5-dev-tools (>= 5.4),
Standards-Version: 4.1.4
Homepage: http://projects.kde.org/kguiaddons
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kguiaddons
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kguiaddons

Package: libkf5guiaddons-dev
Architecture: any
Section: libdevel
Depends: libkf5coreaddons-dev (>= 5.68.0~),
         libkf5guiaddons5 (= ${binary:Version}),
         qtbase5-dev (>= 5.8.0~),
         ${misc:Depends},
Recommends: libkf5guiaddons-doc (= ${source:Version})
Description: development headers for the kguiaddons framework
 This package contains development files for building software that uses
 libraries from the kguiaddon framework

Package: libkf5guiaddons-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: additional addons for QtGui (documentation)
 Qt widgets for colours, fonts and text
 .
 This package contains the qch documentation files.

Package: libkf5guiaddons5
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libkf5kdelibs4support5-bin (<< 5.42)
Description: additional addons for QtGui
 Qt widgets for colours, fonts and text

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

%:
	dh $@ --with kf5,pkgkde_symbolshelper --buildsystem kf5 --without build_stamp

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_QCH=ON

override_dh_strip:
	dh_strip --dbgsym-migration='libkf5guiaddons5-dbg (<= 5.19.0-1~~)'

override_dh_auto_test:
	# Disable auto tests at build time
	:

## kguiaddons 5.74.0

=== debian/changelog ===
kguiaddons (5.74.0-0ubuntu1) groovy; urgency=medium

  * New upstream release (5.74.0)

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Sun, 13 Sep 2020 10:58:59 +0100

kguiaddons (5.73.0-0ubuntu1) groovy; urgency=medium

  * New upstream release (5.73.0)
  * Update install files.
  * Update symbols.

 -- Rik Mills <rikmills@kde.org>  Sat, 08 Aug 2020 10:57:52 +0100

kguiaddons (5.72.0-0ubuntu2) groovy; urgency=medium

  * Disable build-needed testsuite.

 -- Rik Mills <rikmills@kde.org>  Mon, 03 Aug 2020 15:10:56 +0100

kguiaddons (5.72.0-0ubuntu1) groovy; urgency=medium

  * New upstream release (5.72.0)

 -- Rik Mills <rikmills@kde.org>  Mon, 06 Jul 2020 20:32:29 +0100

kguiaddons (5.71.0-0ubuntu1) groovy; urgency=medium

  * New upstream release (5.71.0)

 -- Rik Mills <rikmills@kde.org>  Sun, 14 Jun 2020 12:06:11 +0100

kguiaddons (5.70.0-2ubuntu1) groovy; urgency=medium

  * Merge with debina unstable. Remaining changes:
    - Kubuntu Vcs fields.
    - debhelper-compat = 12 for backports.
    - Keep Kubuntu symbols file.

 -- Rik Mills <rikmills@kde.org>  Tue, 02 Jun 2020 00:06:11 +0100

kguiaddons (5.70.0-2) unstable; urgency=medium

  * Team upload.
  * Restore the libkf5coreaddons-dev dependency in libkf5guiaddons-dev, as one
    header uses CoreAddons. (Closes: #961983)

 -- Pino Toscano <pino@debian.org>  Mon, 01 Jun 2020 23:38:56 +0200

kguiaddons (5.70.0-1ubuntu1) groovy; urgency=medium

  * Merge with debina unstable. Remaining changes:
    - Kubuntu Vcs fields.
    - debhelper-compat = 12 for backports.
    - Keep Kubuntu symbols file. 

 -- Rik Mills <rikmills@kde.org>  Mon, 01 Jun 2020 21:20:10 +0100

kguiaddons (5.70.0-1) unstable; urgency=medium

  * Team upload.

  [ Sandro Knauß ]
  * Bump compat level to 13.
  * New upstream release (5.70.0).
  * Update build-deps and deps with the info from cmake.
  * Wrap long lines in changelog entries: 5.21.0-1.
  * Use secure URI in Homepage field.
  * Set field Upstream-Contact in debian/copyright.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata
    (already present in machine-readable debian/copyright).
  * Remove not needed Depdends for libkf5guiaddons-dev.

 -- Sandro Knauß <hefee@debian.org>  Tue, 26 May 2020 23:55:50 +0200

kguiaddons (5.70.0-0ubuntu1) groovy; urgency=medium

  [ José Manuel Santamaría Lema ]
  * New upstream release (5.69.0)

  [ Rik Mills ]
  * New upstream release (5.70.0)

 -- Rik Mills <rikmills@kde.org>  Sat, 09 May 2020 12:31:45 +0100

kguiaddons (5.69.0-1) experimental; urgency=medium

  * Team upload.

  [ Sandro Knauß ]
  * Bump compat level to 12.
  * Bump Standards-Version to 4.5.0 (No changes needed).
  * Get rid of debug-symbol-migration package.
  * Add Rules-Requires-Root field to control.
  * New upstream release (5.69.0).
  * Update build-deps and deps with the info from cmake.
  * Enable hardening all.
  * Add Build-Depends-Package to symbols file.
  * Update symbols from build for 5.69.0.
  * Remove not needed injection of linker flags.

 -- Sandro Knauß <hefee@debian.org>  Thu, 30 Apr 2020 00:56:05 +0200

kguiaddons (5.62.0-2) unstable; urgency=medium

  * Team upload.

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * Install the kmodifierkey_xcb.so plugin (Closes: #945833). Thanks Luca for
    the bug report and the triaging!
  * Avoid future missing installed parts by passing --fail-missing to
    dh_missing.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Sun, 01 Dec 2019 14:55:18 -0300

kguiaddons (5.62.0-1) unstable; urgency=medium

  * New upstream release (5.62.0).
  * Update build-deps and deps with the info from cmake
  * Release to unstable

 -- Maximiliano Curia <maxy@debian.org>  Fri, 20 Sep 2019 10:13:01 -0700

kguiaddons (5.61.0-1) experimental; urgency=medium

  [ Scarlett Moore ]
  * Fix "kguiaddons FTCBFS: missing Build-Depends: qttools5-dev"
    Build-Depend on qttools5-dev to fix a cross build failure
    (see #915122 for more info). (Closes: #928905)

  [ Maximiliano Curia ]
  * Salsa CI automatic initialization by Tuco
  * New upstream release (5.61.0).
  * Update symbols files.
  * Update build-deps and deps with the info from cmake
  * Release to experimental

 -- Maximiliano Curia <maxy@debian.org>  Mon, 09 Sep 2019 21:10:32 +0100

=== debian/control ===
Source: kguiaddons
Section: libs
Priority: optional
Maintainer: Debian/Kubuntu Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Maximiliano Curia <maxy@debian.org>
Build-Depends: cmake (>= 3.5~),
               debhelper-compat (= 12),
               doxygen,
               extra-cmake-modules (>= 5.74.0~),
               graphviz,
               libqt5sql5-sqlite:native,
               libqt5x11extras5-dev (>= 5.12.0~),
               libx11-dev,
               libxcb1-dev,
               pkg-config,
               pkg-kde-tools (>= 0.15.15ubuntu1~),
               qtbase5-dev (>= 5.12.0~),
               qtbase5-private-dev,
               qttools5-dev,
               qttools5-dev-tools (>= 5.4),
Standards-Version: 4.5.0
Homepage: https://projects.kde.org/kguiaddons
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kguiaddons
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kguiaddons
Rules-Requires-Root: no

Package: libkf5guiaddons-dev
Section: libdevel
Architecture: any
Depends: libkf5coreaddons-dev (>= 5.74.0~),
         libkf5guiaddons5 (= ${binary:Version}),
         qtbase5-dev (>= 5.12.0~),
         ${misc:Depends},
Recommends: libkf5guiaddons-doc (= ${source:Version})
Description: development headers for the kguiaddons framework
 This package contains development files for building software that uses
 libraries from the kguiaddon framework
Breaks: libkf5configwidgets-dev (<< 5.54), libkf5kdelibs4support-dev (<< 5.54)

Package: libkf5guiaddons-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: additional addons for QtGui (documentation)
 Qt widgets for colours, fonts and text
 .
 This package contains the qch documentation files.

Package: libkf5guiaddons5
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: additional addons for QtGui
 Qt widgets for colours, fonts and text
Breaks: libkf5configwidgets5 (<< 5.54),
        libkf5kdelibs4support5 (<< 5.54),
        libkf5kdelibs4support5-bin (<< 5.42),
        libkf5plasma5 (<< 5.54),
        libkf5texteditor5 (<< 5.54)

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with kf5,pkgkde_symbolshelper --buildsystem kf5 --without build_stamp

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_QCH=ON
override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_test:
	# Disable auto tests at build time
	:

## kguiaddons 5.78.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,31 +1,53 @@
 cmake_minimum_required(VERSION 3.5)
 
-set(KF5_VERSION "5.68.0") # handled by release scripts
+set(KF5_VERSION "5.78.0") # handled by release scripts
 project(KGuiAddons VERSION ${KF5_VERSION})
 
 include(FeatureSummary)
-find_package(ECM 5.68.0  NO_MODULE)
+find_package(ECM 5.78.0  NO_MODULE)
 set_package_properties(ECM PROPERTIES TYPE REQUIRED DESCRIPTION "Extra CMake Modules." URL "https://commits.kde.org/extra-cmake-modules")
 feature_summary(WHAT REQUIRED_PACKAGES_NOT_FOUND FATAL_ON_MISSING_REQUIRED_PACKAGES)
 
+
+
+option(BUILD_QCH "Build API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)" OFF)
+add_feature_info(QCH ${BUILD_QCH} "API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)")
+
+if (UNIX AND NOT ANDROID AND NOT APPLE)
+    option(WITH_WAYLAND "Build with support for KeySequenceEditor inhibiting shortcuts on Wayland" ON)
+    add_feature_info(WAYLAND ${WITH_WAYLAND} "KeySequenceEditor inhibiting shortcuts on Wayland")
+else()
+    set(WITH_WAYLAND OFF)
+endif()
 
 set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
 
 include(KDEInstallDirs)
 include(KDEFrameworkCompilerSettings NO_POLICY_SCOPE)
 include(KDECMakeSettings)
-set(REQUIRED_QT_VERSION 5.12.0)
-find_package(Qt5Gui ${REQUIRED_QT_VERSION} REQUIRED NO_MODULE)
+
+set(REQUIRED_QT_VERSION 5.14.0)
+if (WITH_WAYLAND)
+    set(_qtgui_find_components COMPONENTS Private)
+endif()
+# QtGui must be found becore Qt5WaylandClient
+find_package(Qt5Gui ${REQUIRED_QT_VERSION} REQUIRED NO_MODULE ${_qtgui_find_components})
 
 if (NOT APPLE AND NOT WIN32)
     find_package(X11 MODULE)
     find_package(XCB MODULE COMPONENTS XCB)
 endif()
 
+if (WITH_WAYLAND)
+    find_package(Qt5WaylandClient ${REQUIRED_QT_VERSION} NO_MODULE)
+    find_package(QtWaylandScanner REQUIRED)
+    find_package(Wayland 1.9 REQUIRED Client)
+endif()
 
 include(GenerateExportHeader)
 include(ECMSetupVersion)
 include(ECMGenerateHeaders)
+include(ECMQtDeclareLoggingCategory)
 include(ECMAddQch)
 
 ecm_setup_version(PROJECT VARIABLE_PREFIX KGUIADDONS
@@ -33,9 +55,8 @@
                         PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KF5GuiAddonsConfigVersion.cmake"
                         SOVERSION 5)
 
-option(BUILD_QCH "Build API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)" OFF)
-add_feature_info(QCH ${BUILD_QCH} "API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)")
-add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x050d00)
+
+add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x050e00)
 add_definitions(-DQT_NO_FOREACH)
 add_subdirectory(src)
 if (BUILD_TESTING)

=== autotests/CMakeLists.txt ===
find_package(Qt5 ${REQUIRED_QT_VERSION} CONFIG REQUIRED Test)

remove_definitions(-DQT_NO_CAST_FROM_ASCII)

include(ECMAddTests)

ecm_add_tests(
  kwordwraptest.cpp
  kcolorutilstest.cpp
  kiconutilstest.cpp
  kcursorsavertest.cpp
  keysequencerecordertest.cpp
  LINK_LIBRARIES KF5::GuiAddons Qt5::Test
)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -12,11 +12,33 @@
  util/kmodifierkeyinfo.cpp
  util/kmodifierkeyinfoprovider.cpp
  util/urlhandler.cpp
+ util/kcursorsaver.cpp
+ recorder/keyboardgrabber.cpp
+ recorder/keysequencerecorder.cpp
 )
+
 
 set (kguiaddons_LIB_SRCS ${kguiaddons_LIB_SRCS} util/kmodifierkeyinfoprovider.cpp)
 
+ecm_qt_declare_logging_category(kguiaddons_LIB_SRCS
+    HEADER kguiaddons_debug.h
+    IDENTIFIER KGUIADDONS_LOG
+    CATEGORY_NAME kf.guiaddons
+    DESCRIPTION "KGuiAddons"
+    EXPORT KGUIADDONS
+)
+
 add_library(KF5GuiAddons ${kguiaddons_LIB_SRCS})
+
+if(WITH_WAYLAND)
+    ecm_add_qtwayland_client_protocol(wayland_SRCS
+        PROTOCOL recorder/keyboard-shortcuts-inhibit-unstable-v1.xml
+        BASENAME keyboard-shortcuts-inhibit-unstable-v1
+    )
+    target_sources(KF5GuiAddons PRIVATE recorder/waylandinhibition.cpp ${wayland_SRCS})
+    target_compile_definitions(KF5GuiAddons PRIVATE WITH_WAYLAND)
+    target_link_libraries(KF5GuiAddons PRIVATE Qt5::GuiPrivate Qt5::WaylandClient Wayland::Client)
+endif()
 
 generate_export_header(KF5GuiAddons BASE_NAME KGuiAddons)
 add_library(KF5::GuiAddons ALIAS KF5GuiAddons)
@@ -26,6 +48,7 @@
   ${CMAKE_CURRENT_SOURCE_DIR}/fonts
   ${CMAKE_CURRENT_SOURCE_DIR}/text
   ${CMAKE_CURRENT_SOURCE_DIR}/util
+  ${CMAKE_CURRENT_SOURCE_DIR}/recorder
   )
 target_include_directories(KF5GuiAddons PUBLIC "$<BUILD_INTERFACE:${kguiaddons_INCLUDES}>")
 target_include_directories(KF5GuiAddons INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR_KF5}/KGuiAddons>" )
@@ -81,9 +104,18 @@
   KIconUtils
   KImageCache
   KModifierKeyInfo
+  KCursorSaver
 
   RELATIVE util
   REQUIRED_HEADERS KGuiAddons_HEADERS
+)
+
+ecm_generate_headers(KGuiAddons_HEADERS
+    HEADER_NAMES
+    KeySequenceRecorder
+
+    RELATIVE recorder
+    REQUIRED_HEADERS KGuiAddons_HEADERS
 )
 
 find_package(PythonModuleGeneration)
@@ -143,3 +175,9 @@
 include(ECMGeneratePriFile)
 ecm_generate_pri_file(BASE_NAME KGuiAddons LIB_NAME KF5GuiAddons DEPS "gui" FILENAME_VAR PRI_FILENAME INCLUDE_INSTALL_DIR ${KDE_INSTALL_INCLUDEDIR_KF5}/KGuiAddons)
 install(FILES ${PRI_FILENAME} DESTINATION ${ECM_MKSPECS_INSTALL_DIR})
+
+ecm_qt_install_logging_categories(
+    EXPORT KGUIADDONS
+    FILE kguiaddons.categories
+    DESTINATION "${KDE_INSTALL_LOGGINGCATEGORIESDIR}"
+)

=== tests/CMakeLists.txt ===
remove_definitions(-DQT_NO_CAST_FROM_ASCII)
remove_definitions(-DQT_NO_CAST_TO_ASCII)

include(ECMMarkAsTest)

find_package(Qt5 ${REQUIRED_QT_VERSION} CONFIG REQUIRED Test Widgets)

macro(kguiaddons_executable_tests)
  foreach(_testname ${ARGN})
    add_executable(${_testname} ${_testname}.cpp)
    target_link_libraries(${_testname} Qt5::Widgets KF5::GuiAddons)
    ecm_mark_as_test(${_testname})
  endforeach(_testname)
endmacro()

kguiaddons_executable_tests(
  kcolorcollectiontest
  kmodifierkeyinfotest
  openurltest
  kcursorsavergui_test
)

=== debian/changelog ===
kguiaddons (5.78.0-3) unstable; urgency=medium

  * Release to unstable.

 -- Norbert Preining <norbert@preining.info>  Sun, 17 Jan 2021 12:02:21 +0900

kguiaddons (5.78.0-2) experimental; urgency=medium

  * Fix incorrect B-D.

 -- Norbert Preining <norbert@preining.info>  Wed, 13 Jan 2021 21:10:51 +0900

kguiaddons (5.78.0-1) experimental; urgency=medium

  [ Norbert Preining ]
  * New upstream release (5.78.0).

 -- Norbert Preining <norbert@preining.info>  Wed, 13 Jan 2021 10:32:42 +0900

kguiaddons (5.77.0-4) unstable; urgency=medium

  * Team upload.
  * Allow kguiaddons to build again on non-Linux architectures:
    (Closes: #978164)
    - limit the libqt5waylandclient5-dev, libwayland-dev, and
      qtwayland5-dev-tools build dependencies as linux-any
    - pass -DWITH_WAYLAND=OFF to cmake on non-Linux architectures
    - limit two symbols as linux-any

 -- Pino Toscano <pino@debian.org>  Sun, 27 Dec 2020 10:50:45 +0100

kguiaddons (5.77.0-3) unstable; urgency=medium

  * Release to unstable.

 -- Norbert Preining <norbert@preining.info>  Tue, 22 Dec 2020 10:33:34 +0900

kguiaddons (5.77.0-2) experimental; urgency=medium

  [ Norbert Preining ]
  * Update build-deps and deps with the info from cmake.

 -- Norbert Preining <norbert@preining.info>  Fri, 18 Dec 2020 15:53:13 +0900

kguiaddons (5.77.0-1) experimental; urgency=medium

  [ Norbert Preining ]
  * Bump Standards-Version to 4.5.1 (No changes needed).
  * New upstream release (5.77.0).
  * Add myself to Uploaders.
  * Update maintainer to Debian Qt/KDE Maintainers.
  * Update symbols.

 -- Norbert Preining <norbert@preining.info>  Fri, 18 Dec 2020 10:03:53 +0900

kguiaddons (5.74.0-3) unstable; urgency=medium

  * Team upload.
  * Drop the 'testsuite' autopkgtest, as it does not test the installed
    packages.
  * Remove the unused debian/meta/ stuff.
  * Do not ship anymore the almost empty upstream README.md as documentation
    in libkf5guiaddons-dev.
  * Stop passing --fail-missing to dh_missing, as it is the default in
    debhelper compatibility 13+.
  * Pass -DBUILD_TESTING=OFF to cmake to disable the build of tests, as they
    are not run at build time anyway.
  * Restore (again) the libkf5coreaddons-dev dependency in libkf5guiaddons-dev,
    as one header uses CoreAddons.

 -- Pino Toscano <pino@debian.org>  Fri, 23 Oct 2020 15:02:33 +0200

kguiaddons (5.74.0-2) unstable; urgency=medium

  * Team upload to unstable.

 -- Sandro Knauß <hefee@debian.org>  Mon, 19 Oct 2020 23:14:26 +0200

kguiaddons (5.74.0-1) experimental; urgency=medium

  * Team upload.

  [ Sandro Knauß ]
  * New upstream release (5.74.0).
  * Update build-deps and deps with the info from cmake.
  * Add categories file to libkf5guiaddons5.
  * remove libkf5coreaddons-dev from libkf5guiaddons-dev depends.
  * Update Homepage link to point to new invent.kde.org
  * Update repository related entries to metadata file.
  * Update field Source in debian/copyright to invent.kde.org move.
  * Add Bug-* entries to metadata file.
  * Update symbols from build for 5.74.0.

 -- Sandro Knauß <hefee@debian.org>  Sun, 27 Sep 2020 17:44:20 +0200

=== debian/control ===
Source: kguiaddons
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Maximiliano Curia <maxy@debian.org>,
           Norbert Preining <norbert@preining.info>,
Build-Depends: cmake (>= 3.5~),
               debhelper-compat (= 13),
               doxygen,
               extra-cmake-modules (>= 5.78.0~),
               graphviz,
               libqt5sql5-sqlite:native,
               libqt5waylandclient5-dev (>= 5.13.0~) [linux-any],
               libqt5x11extras5-dev (>= 5.13.0~),
               libwayland-dev (>= 1.9~) [linux-any],
               libx11-dev,
               libxcb1-dev,
               pkg-config,
               pkg-kde-tools (>= 0.15.15ubuntu1~),
               qtbase5-dev (>= 5.13.0~),
               qtbase5-private-dev,
               qttools5-dev,
               qttools5-dev-tools (>= 5.4),
               qtwayland5-dev-tools (>= 5.13.0~) [linux-any],
Standards-Version: 4.5.1
Homepage: https://invent.kde.org/frameworks/kguiaddons
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kguiaddons
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kguiaddons.git
Rules-Requires-Root: no

Package: libkf5guiaddons-dev
Section: libdevel
Architecture: any
Depends: libkf5coreaddons-dev (>= 5.77.0~),
         libkf5guiaddons5 (= ${binary:Version}),
         qtbase5-dev (>= 5.13.0~),
         ${misc:Depends},
Recommends: libkf5guiaddons-doc (= ${source:Version})
Description: development headers for the kguiaddons framework
 This package contains development files for building software that uses
 libraries from the kguiaddon framework
Breaks: libkf5configwidgets-dev (<< 5.54), libkf5kdelibs4support-dev (<< 5.54)

Package: libkf5guiaddons-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: additional addons for QtGui (documentation)
 Qt widgets for colours, fonts and text
 .
 This package contains the qch documentation files.

Package: libkf5guiaddons5
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: additional addons for QtGui
 Qt widgets for colours, fonts and text
Breaks: libkf5configwidgets5 (<< 5.54),
        libkf5kdelibs4support5 (<< 5.54),
        libkf5kdelibs4support5-bin (<< 5.42),
        libkf5plasma5 (<< 5.54),
        libkf5texteditor5 (<< 5.54),

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk

ifneq (linux,$(DEB_HOST_ARCH_OS))
EXTRA_CMAKE_ARGS += -DWITH_WAYLAND=OFF
endif

%:
	dh $@ --with kf5,pkgkde_symbolshelper --buildsystem kf5 --without build_stamp

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_QCH=ON -DBUILD_TESTING=OFF $(EXTRA_CMAKE_ARGS)

override_dh_auto_test:
	# Disable auto tests at build time
	:

## kguiaddons 5.80.0

=== debian/changelog ===
kguiaddons (5.80.0-0ubuntu1) hirsute; urgency=medium

  * New upstream release (5.80.0)

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Thu, 18 Mar 2021 11:07:41 +0000

kguiaddons (5.79.0-0ubuntu1) hirsute; urgency=medium

  * New upstream release (5.79.0)

 -- Rik Mills <rikmills@kde.org>  Sat, 13 Feb 2021 12:21:37 +0000

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Build-Depends: cmake (>= 3.5~),
                debhelper-compat (= 13),
                doxygen,
-               extra-cmake-modules (>= 5.78.0~),
+               extra-cmake-modules (>= 5.80.0~),
                graphviz,
                libqt5sql5-sqlite:native,
                libqt5waylandclient5-dev (>= 5.13.0~) [linux-any],
@@ -31,7 +31,7 @@
 Package: libkf5guiaddons-dev
 Section: libdevel
 Architecture: any
-Depends: libkf5coreaddons-dev (>= 5.77.0~),
+Depends: libkf5coreaddons-dev (>= 5.80.0~),
          libkf5guiaddons5 (= ${binary:Version}),
          qtbase5-dev (>= 5.13.0~),
          ${misc:Depends},

## kguiaddons 5.86.0

=== debian/changelog ===
kguiaddons (5.86.0-0ubuntu1) impish; urgency=medium

  * New upstream release (5.86.0)

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Mon, 13 Sep 2021 12:47:51 +0100

kguiaddons (5.85.0-0ubuntu1) impish; urgency=medium

  * New upstream release (5.85.0)

 -- Rik Mills <rikmills@kde.org>  Fri, 13 Aug 2021 11:26:51 +0100

kguiaddons (5.84.0-0ubuntu1) impish; urgency=medium

  * New upstream release (5.84.0)
  * Update symbols

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Sun, 11 Jul 2021 09:00:02 +0100

kguiaddons (5.83.0-0ubuntu1) impish; urgency=medium

  * New upstream release (5.83.0)

 -- Rik Mills <rikmills@kde.org>  Sat, 12 Jun 2021 12:16:58 +0100

kguiaddons (5.82.0-0ubuntu1) impish; urgency=medium

  * New upstream release (5.82.0)
  * Update symbols

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Sat, 08 May 2021 11:56:27 +0100

kguiaddons (5.81.0-0ubuntu1) impish; urgency=medium

  * New upstream release (5.81.0)

 -- Rik Mills <rikmills@kde.org>  Wed, 28 Apr 2021 10:29:09 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Build-Depends: cmake (>= 3.5~),
                debhelper-compat (= 13),
                doxygen,
-               extra-cmake-modules (>= 5.80.0~),
+               extra-cmake-modules (>= 5.86.0~),
                graphviz,
                libqt5sql5-sqlite:native,
                libqt5waylandclient5-dev (>= 5.13.0~) [linux-any],
@@ -31,7 +31,7 @@
 Package: libkf5guiaddons-dev
 Section: libdevel
 Architecture: any
-Depends: libkf5coreaddons-dev (>= 5.80.0~),
+Depends: libkf5coreaddons-dev (>= 5.86.0~),
          libkf5guiaddons5 (= ${binary:Version}),
          qtbase5-dev (>= 5.13.0~),
          ${misc:Depends},
